unit sIBFilter;
(************************************************************************
sStyle components package 
Copyright (c) 2002 Serge Goncharov. All rights reserved.
                            Ukraine, Odessa
                            http://www.geocities.com/sstylish2002/
                            Serge@HyBce.com
 Version:	1.2, 24-02-2002
*************************************************************************)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  sIBFilterForm, IBQuery;

type
  TIBFilter = class(TComponent)
  private
    HeForm : TsIBFilterForm;
    FQuery : TIBQuery;
    FTableName : string;
    FOrderStr : string;
    { Private declarations }
  protected
    { Protected declarations }
  public
    SelectText : string;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function Execute: Boolean;
    { Public declarations }
  published
    property Query : TIBQuery read FQuery write FQuery;
    property TableName : string read FTableName write FTableName;
    property OrderStr : string read FOrderStr write FOrderStr;
    { Published declarations }
  end;

  TsIBFilter = class(TComponent)
  private
    FQuery : TIBQuery;
    FTableName : string;
    FOrderStr : string;
    { Private declarations }
  protected
    { Protected declarations }
  public
    HeForm : TsIBFilterForm;
    SelectText : string;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function Execute: Boolean;
    { Public declarations }
  published
    property Query : TIBQuery read FQuery write FQuery;
    property TableName : string read FTableName write FTableName;
    property OrderStr : string read FOrderStr write FOrderStr;
    { Published declarations }
  end;

function CreateFilterForm(AOwner:TComponent): TsIBFilterForm;

implementation

destructor TIBFilter.Destroy;
begin
  if Assigned(HeForm) then HeForm.Free;
  inherited Destroy;
end;

function TIBFilter.Execute:Boolean;
begin
  HeForm.DS := Query;
  HeForm.Query1.Database := Query.Database;
  HeForm.TableName := TableName;
  HeForm.SelectText := SelectText;
  HeForm.OrderStr := OrderStr;
  HeForm.ShowModal;
  Result := True;
end;

constructor TIBFilter.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);
  if not (csDesigning in ComponentState) then begin
    HeForm := CreateFilterForm(Self);
  end;
end;

function CreateFilterForm(AOwner:TComponent): TsIBFilterForm;
begin
  Result:=TsIBFilterForm.Create(AOwner);
end;

destructor TsIBFilter.Destroy;
begin
  if Assigned(HeForm) then HeForm.Free;
  inherited Destroy;
end;

function TsIBFilter.Execute:Boolean;
begin
  HeForm.DS := Query;
  HeForm.Query1.Database := Query.Database;
  HeForm.TableName := TableName;
  HeForm.SelectText := SelectText;
  HeForm.OrderStr := OrderStr;
  HeForm.ShowModal;
  Result := True;
end;

constructor TsIBFilter.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);
  if not (csDesigning in ComponentState) then begin
    HeForm := CreateFilterForm(Self);
  end;
end;

end.
