unit sUtils;
(************************************************************************
sStyle components package 
Copyright (c) 2002 Serge Goncharov. All rights reserved.
                            Ukraine, Odessa
                            http://www.geocities.com/sstylish2002/
                            Serge@HyBce.com
 Version:	1.2, 24-02-2002
*************************************************************************)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, sConst, ExtCtrls, StrUtils;

procedure ALERT;
function Between(Value, i1, i2 : integer) : boolean;
function Maxi(i1, i2 : integer) : integer;
function Mini(i1, i2 : integer) : integer;
//<<<<<<<<<<       <<<<<<<<<<<<<<<<
{         }
function iff(L : boolean; s1, s2 : string) : string;
{
function iff(L : boolean; s1, s2 : integer) : integer; overload;
function iff(L : boolean; s1, s2 : real) : real; overload;
}
function iffo(L : boolean; o1, o2 : TObject) : TObject;
{          }
function iffi(L : boolean; i1, i2 : integer) : integer;
{  }
function CorrectString(s : string) : string;
{   }
function SubStrInclude(SubString, s : string; CaseInsensitive : boolean) : boolean;
function GetWordNumber(const W, S: string; const WordDelims: TCharSet): integer;

{      }
function FIOLongToShort(s:string):string;
function StrToFloatR (Field1 : string) : real;
function CurRound(f : real) : real;
function GetSelectFromSQL(s : string) : string;
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
{    }
function DeleteRequest:boolean;
{ }
function CustomRequest(s : string):boolean;
{   mtWarning}
procedure ShowWarning(s:string);
{   mtError}
procedure ShowError(s:string);
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
procedure Delay(MSecs: Integer);

implementation

procedure ALERT;
begin
  ShowWarning('!');
end;

function iff(L : boolean; s1, s2 : string) : string;
begin
  if l then Result := s1 else Result := s2;
end;
{
function iff(L : boolean; s1, s2 : integer) : integer; overload;
begin
  if l then Result := s1 else Result := s2;
end;

function iff(L : boolean; s1, s2 : real) : real; overload;
begin
  if l then Result := s1 else Result := s2;
end;
}
function iffo(L : boolean; o1, o2 : TObject) : TObject;
begin
  if l then Result := o1 else Result := o2;
end;

function iffi(L : boolean; i1, i2 : integer) : integer;
begin
  if l then Result := i1 else Result := i2;
end;

function Between(Value, i1, i2 : integer) : boolean;
begin
  Result := (Value >= i1) and (Value <= i2);
end;

function Maxi(i1, i2 : integer) : integer;
begin
  if i1 > i2 then Result := i1 else Result := i2;
end;

function Mini(i1, i2 : integer) : integer;
begin
  if i1 > i2 then Result := i2 else Result := i1;
end;

function CorrectString(s : string) : string;
begin
  s := StrUtils.DelRSpace(s);
  s := StrUtils.DelSpace1(s);
  s := StrUtils.ReplaceStr(s, '''', '`');
  s := StrUtils.ReplaceStr(s, '', 'I');
  Result := s;
end;

function SubStrInclude(SubString, s : string; CaseInsensitive : boolean) : boolean;
begin
  if CaseInsensitive then begin
    Result := pos(UpperCase(SubString), UpperCase(s)) > 0;
  end
  else begin
    Result := pos(SubString, s) > 0;
  end;
end;

function GetWordNumber(const W, S: string; const WordDelims: TCharSet): integer;
var
  Count, i: Integer;
begin
  Result := -1;
  Count := WordCount(S, WordDelims);
  for i := 1 to Count do begin
    if ExtractWord(i, S, WordDelims) = W then begin
      Result := i;
      Exit;
    end;
  end;
end;

function FIOLongToShort(s:string):string;
begin
  s := StrUtils.AnsiProperCase(s, [' ']);
  Result := ExtractWord(2, s, [' ']) + ' ' + copy(ExtractWord(2, s, [' ']), 1, 1) + '. ' + copy(ExtractWord(3, s, [' ']), 1, 1) + '. ';
end;

function StrToFloatR (Field1 : string) : real;
begin
  if Field1 = '' then result := 0
  else result := StrToFloat(Field1);
end;

function CurRound(f : real) : real;
begin
  Result := Round((f+0.000001)*100)/100;
end;

function GetSelectFromSQL(s : string) : string;
begin
  if pos('WHERE', UpperCase(s)) > 0 then begin
    Result := copy(s, 1, pos('WHERE', UpperCase(s))-1);
  end
  else if pos('ORDER BY', UpperCase(s)) > 0 then begin
    Result := copy(s, 1, pos('ORDER BY', UpperCase(s))-1);
  end
  else if pos('GROUP BY', UpperCase(s)) > 0 then begin
    Result := copy(s, 1, pos('GROUP BY', UpperCase(s))-1);
  end
  else Result := s;
end;

////// Dialogs
function DeleteRequest:boolean;
begin
//  DropDownBeep;
  Result:=MessageDlg('    ?', mtConfirmation, [mbYes, mbNo], 0)=mrYes;
end;

function CustomRequest(s : string):boolean;
begin
//  DropDownBeep;
  Result:=MessageDlg(s, mtConfirmation, [mbYes, mbNo], 0)=mrYes;
end;

procedure ShowWarning(s:string);
begin
  MessageDlg(s, mtWarning, [mbOk], 0);
end;

procedure ShowError(s:string);
begin
  MessageDlg(s, mtError, [mbOk], 0);
end;

procedure Delay(MSecs: Integer);
var
  FirstTickCount : LongInt;
begin
  FirstTickCount:=GetTickCount;
  repeat
    Application.ProcessMessages;
  until ((GetTickCount-FirstTickCount) >= LongInt(MSecs));
end;

end.
